unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, GLScene, GLObjects, GLTeapot, GLCoordinates, GLCrossPlatform,
  BaseClasses, GLWin32Viewer, GLSkydome, ExtCtrls, StdCtrls, GLGeomObjects,
  GLPolyhedron, GLColor;

type
  TForm1 = class(TForm)
    GLScene1: TGLScene;
    GLCamera1: TGLCamera;
    GLLightSource1: TGLLightSource;
    GLPlane1: TGLPlane;
    GLDummyCube1: TGLDummyCube;
    Button1: TButton;
    Label1: TLabel;
    GLSceneViewer1: TGLSceneViewer;
    GLPolygon1: TGLPolygon;
    Button2: TButton;
    Label2: TLabel;
    Label3: TLabel;
    Edit1: TEdit;
    procedure GLSceneViewer1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure GLSceneViewer1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormCreate(Sender: TObject);
    procedure FormMouseWheelDown(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
    procedure FormMouseWheelUp(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
    px,py     : integer;
    ss        : single;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

function fun(x,y : single):single;
begin
  fun := (x-2)*(x+2)/4 + (y-2)*(y+2)/4;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  ss := GLCamera1.SceneScale;
end;

procedure TForm1.FormMouseWheelDown(Sender: TObject; Shift: TShiftState;
  MousePos: TPoint; var Handled: Boolean);
begin
  ss := ss - 0.01;
  if (ss <= 0.2) then ss := 0.2;
  GLCamera1.SceneScale := ss;
end;

procedure TForm1.FormMouseWheelUp(Sender: TObject; Shift: TShiftState;
  MousePos: TPoint; var Handled: Boolean);
begin
  ss := ss + 0.01;
  if (ss > 2.5) then ss := 2.5;
  GLCamera1.SceneScale := ss;
end;

procedure TForm1.GLSceneViewer1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  px := X;
  py := Y;
end;

procedure TForm1.GLSceneViewer1MouseMove(
  Sender: TObject;
  Shift: TShiftState;
  X, Y: Integer);
begin
  if ssLeft in Shift then begin
    GLCamera1.MoveAroundTarget(py-Y,px-X);
    px := X;
    py := Y;
  end;
end;

// Cinta
// circulo en X-Y
// Crezca en Z
procedure TForm1.Button2Click(Sender: TObject);
var
  x1,x2,y1,y2,
  x,dx,y,dy      : single;
  k,n,neb,j      : integer;
  tri            : TGLPolygon;
  obj            : TGLBaseSceneObject;
begin
  GLPlane1.Visible := false;
  // quitar los poligonos
  neb := GLScene1.Objects.Count;
  for k := neb-1 downto 0 do begin
    obj := GLScene1.Objects[k];
    if (obj is TGLPolygon) then obj.Free;
  end;

  n := StrToInt(Edit1.Text);

  x1 := -2;
  dx := 4/(n-1);

  y1 := -2;
  dy := 4/(n-1);

  for j := 0 to n-2 do begin
    y2 := y1 + dy;
    for k := 0 to n - 2 do begin
      // primer Triangulo
      tri := TGLPolygon.Create(self);
      tri.Material.FrontProperties.Emission.Color := clrBlue;

      x2 := x1 + dx;

      tri.Nodes.AddNode(x1,y2,fun(x1,y2));
      tri.Nodes.AddNode(x2,y1,fun(x2,y1));
      tri.Nodes.AddNode(x1,y1,fun(x1,y1));

      GLScene1.Objects.AddChild(tri);

      // segundo Triangulo
      tri := TGLPolygon.Create(self);
      tri.Material.FrontProperties.Emission.Color := clrRed;

      tri.Nodes.AddNode(x1,y2,fun(x1,y2) );
      tri.Nodes.AddNode(x2,y2,fun(x2,y2) );
      tri.Nodes.AddNode(x2,y1,fun(x2,y1) );

      GLScene1.Objects.AddChild(tri);

      x1 := x2;
    end;
    x1 := -2;
    y1 := y1 + dy;
  end;
end;


end.
